var BLOCK_SIZE = 8;
var _mainCanvas, _mainContext;
var _hiddenCanvas, _hiddenContext;
var _bitmap;

$(function () {	

	if (!(window.File && window.FileReader && window.FileList)) {
		$('#progress_bar').hide();
		$('#mainLoad').hide();	
		$("#picker").attr('disabled','disabled');
		$('#error_message').text("This browser does not support HTML5 file loading");
		return;
	}	

	// Create a secondary canvas and a rendering context to go with it
	_hiddenCanvas = document.createElement("canvas");
	_hiddenContext = _hiddenCanvas.getContext("2d");

	// Make sure the canvas API is supported
	if (!_hiddenContext) {
		$('#progress_bar').hide();
		$('#mainLoad').hide();		
		$("#picker").attr('disabled','disabled');
		$('#error_message').text("This browser does not support HTML5 canvas");
		return;
	}
	
	// Get a reference to the main canvas and a rendering context
	_mainCanvas = document.getElementById("photo");
	_mainContext = _mainCanvas.getContext("2d");

	// Attach a change handler to the file-input field
	$("#picker").change(onFileSelected);  
});

function updateProgress(e) {

	// E is a ProgressEvent.
	if (e.lengthComputable) {
	
		var percentLoaded = Math.round((e.loaded / e.total) * 100);
	 
	    // Increase the progress bar length.
	    if (percentLoaded < 100) {
	        $('.percent').css('width', percentLoaded + '%');
		    $('.percent').text(percentLoaded + '%');  
			$('#html5progressBar').value = percentLoaded;
	    }
	}
}

function onFileSelected(e) {

	// Make sure the file API is supported
	if (!(window.File && window.FileReader && window.FileList)) {		
		return;
	}

    // Reset progress indicator on new file selection.
    $('.percent').css('width','0%');
	$('.percent').text('0%');   

	// Get a File object representing the selected file
	var file = e.target.files[0];
	
	// Make sure it's an image file
	if (!file.type.match("image.*")) {
		alert("\"" + file.name + "\" is not an image file");
		return;
	}

	// Create a FileReader object and read the file's contents
	var reader = new FileReader();
	
	// Get the progress event
	reader.onprogress = updateProgress;
	 
	reader.onloadstart = function(e) {
	    document.getElementById('progress_bar').className = 'loading';
	};

	reader.onload = function (e) {
	
		image = new Image();

		image.onload = function () {
		
		    // Ensure that the progress bar displays 100% at the end.
	        $('.percent').css('width','100%');
	        $('.percent').text('100%');   
            setTimeout("document.getElementById('progress_bar').className='';", 5000);
		
			// Set the width and height of the canvas based on the image size
			var width = image.width;
			var height = image.height;
			var ratio = height / width;

			_mainCanvas.width = Math.min(500, width);
			_mainCanvas.height = _mainCanvas.width * ratio;

			// Convert the image into an ImageData object by drawing it to
			// the hidden canvas and calling getImageData on that canvas
			_hiddenCanvas.width = image.width;
			_hiddenCanvas.height = image.height;
			_hiddenContext.drawImage(image, 0, 0, _hiddenCanvas.width, _hiddenCanvas.height);
			_bitmap = _hiddenContext.getImageData(0, 0, _hiddenCanvas.width, _hiddenCanvas.height);

			// Transfer (and scale) the image from the hidden canvas to the main canvas
			_mainContext.drawImage(_hiddenCanvas, 0, 0, _mainCanvas.width, _mainCanvas.height);
		}

		// Point the image to the file that the user selected
		image.src = e.target.result;
	}

	// Read the contents of the image file as a data URL
	reader.readAsDataURL(file);
}
